const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const club_memberships = sequelize.define(
    'club_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

club_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"manager",


"member"

        ],

      },

member_code: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

member_since_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  club_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.club_memberships.belongsTo(db.clubs, {
      as: 'club',
      foreignKey: {
        name: 'clubId',
      },
      constraints: false,
    });

    db.club_memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.club_memberships.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.club_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.club_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return club_memberships;
};


